Attribute VB_Name = "modMiscStuff"
Option Explicit

Public Declare Function InternetOpen _
                    Lib "wininet" _
                  Alias "InternetOpenA" _
                        (ByVal pszAgent As String, _
                         ByVal dwAccessType As Long, _
                         ByVal lpszProxyName As String, _
                         ByVal lpszProxyByPass As String, _
                         ByVal dwFlags As Long) As Long

Public Declare Function InternetConnect _
                    Lib "wininet" _
                  Alias "InternetConnectA" _
                        (ByVal hInternet As Long, _
                         ByVal lpszServerName As String, _
                         ByVal nPort As Long, _
                         ByVal lpszUsername As String, _
                         ByVal lpszPassword As String, _
                         ByVal dwService As Long, _
                         ByVal dwFlags As Long, _
                               dwContext As Any) As Long


Public Declare Function InternetCloseHandle _
                    Lib "wininet" _
                        (ByVal hInternet As Long) As Long
                        
Public Declare Function InternetSetStatusCallback _
                    Lib "wininet" _
                        (ByVal hInternet As Long, _
                         ByVal pCallbackProc As Long) As Long
                        

Private Const INTERNET_STATUS_CLOSING_CONNECTION = 50     ' Closing the connection to the server. The lpvStatusInformation parameter is NULL.
Private Const INTERNET_STATUS_CONNECTED_TO_SERVER = 21    ' Successfully connected to the socket address (SOCKADDR) pointed to by lpvStatusInformation.
Private Const INTERNET_STATUS_CONNECTING_TO_SERVER = 20   ' Connecting to the socket address (SOCKADDR) pointed to by lpvStatusInformation.
Private Const INTERNET_STATUS_CONNECTION_CLOSED = 51      ' Successfully closed the connection to the server. The lpvStatusInformation parameter is NULL.
Private Const INTERNET_STATUS_CTL_RESPONSE_RECEIVED = 42  ' Not implemented
Private Const INTERNET_STATUS_DETECTING_PROXY = 80        ' Notifies the client application that a proxy has been detected.
Private Const INTERNET_STATUS_HANDLE_CLOSING = 70         ' This handle value has been terminated.
Private Const INTERNET_STATUS_HANDLE_CREATED = 60         ' Used by InternetConnect to indicate it has created the new handle. This lets the application call InternetCloseHandle from another thread, if the connect is taking too long. The lpvStatusInformation parameter contains the address of an INTERNET_ASYNC_RESULT structure.
Private Const INTERNET_STATUS_INTERMEDIATE_RESPONSE = 120 ' Received an intermediate (100 level) status code message from the server.
Private Const INTERNET_STATUS_NAME_RESOLVED = 11          ' Successfully found the IP address of the name contained in lpvStatusInformation.
Private Const INTERNET_STATUS_PREFETCH = 43               ' Not implemented
Private Const INTERNET_STATUS_RECEIVING_RESPONSE = 40     ' Waiting for the server to respond to a request. The lpvStatusInformation parameter is NULL.
Private Const INTERNET_STATUS_REDIRECT = 110              ' An HTTP request is about to automatically redirect the request. The lpvStatusInformation parameter points to the new URL. At this point, the application can read any data returned by the server with the redirect response and can query the response headers. It can also cancel the operation by closing the handle. This callback is not made if the original request specified INTERNET_FLAG_NO_AUTO_REDIRECT.
Private Const INTERNET_STATUS_REQUEST_COMPLETE = 100      ' An asynchronous operation has been completed. The lpvStatusInformation parameter contains the address of an INTERNET_ASYNC_RESULT structure.
Private Const INTERNET_STATUS_REQUEST_SENT = 31           ' Successfully sent the information request to the server. The lpvStatusInformation parameter points to a DWORD containing the number of bytes sent.
Private Const INTERNET_STATUS_RESOLVING_NAME = 10         ' Looking up the IP address of the name contained in lpvStatusInformation.
Private Const INTERNET_STATUS_RESPONSE_RECEIVED = 41      ' Successfully received a response from the server. The lpvStatusInformation parameter points to a DWORD containing the number of bytes received.
Private Const INTERNET_STATUS_SENDING_REQUEST = 30        ' Sending the information request to the server. The lpvStatusInformation parameter is NULL.
Private Const INTERNET_STATUS_STATE_CHANGE = 200          ' Moved between a secure (HTTPS) and a nonsecure (HTTP) site. This can be one of the following values:
Private Const INTERNET_STATE_CONNECTED = &H1              ' Connected state (mutually exclusive with disconnected state).
Private Const INTERNET_STATE_DISCONNECTED = &H2           ' Disconnected state. No network connection could be established.
Private Const INTERNET_STATE_DISCONNECTED_BY_USER = &H10  ' Disconnected by user request.
Private Const INTERNET_STATE_IDLE = &H100                 ' No network requests are being made by the Microsoft Win32 Internet functions.
Private Const INTERNET_STATE_BUSY = &H200                 ' Network requests are being made by the Win32 Internet functions.
Private Const INTERNET_STATUS_USER_INPUT_REQUIRED = 140   ' The request requires user input to be completed.


Public Const INTERNET_FLAG_ASYNC As Long = &H10000000
Public Const INTERNET_SERVICE_FTP As Long = 1


Public Type MY_CTX
    HostWnd             As HostWindow
    ConnectionWnd       As ConnectionWindow
    ConnectionHandle    As Long
End Type

Dim MyCtx As MY_CTX




Public Sub CommonCallback(ByVal hInternet As Long, _
                          ByRef ctx As MY_CTX, _
                          ByVal dwInetStatus As Long, _
                          ByVal lpvStatusInfo As Long, _
                          ByVal dwStatusInfoLength As Long)
                          
    Debug.Print "XXX_Callback: i am here. dwInetStatus = "; TranslateStatusId(dwInetStatus)
    
    DoEvents
    
    Select Case dwInetStatus
        Case INTERNET_STATUS_HANDLE_CREATED
            '
            '   ,    .
            '
            
            ctx.ConnectionHandle = lpvStatusInfo
            ctx.ConnectionWnd.Show vbModeless, ctx.HostWnd
        
        Case INTERNET_STATUS_RESOLVING_NAME
            ctx.ConnectionWnd.SetConnectionStatus "  ..."

        Case INTERNET_STATUS_NAME_RESOLVED
            ctx.ConnectionWnd.SetConnectionStatus "  ."
            
        Case INTERNET_STATUS_CONNECTING_TO_SERVER
            ctx.ConnectionWnd.SetConnectionStatus "   ..."
            
        Case INTERNET_STATUS_CONNECTED_TO_SERVER
            ctx.ConnectionWnd.SetConnectionStatus "   ."
    End Select

End Sub

Public Function TranslateStatusId(ByVal id As Long) As String
    Select Case id
        Case INTERNET_STATUS_CLOSING_CONNECTION:    TranslateStatusId = "INTERNET_STATUS_CLOSING_CONNECTION"
        Case INTERNET_STATUS_CONNECTED_TO_SERVER:   TranslateStatusId = "INTERNET_STATUS_CONNECTED_TO_SERVER"
        Case INTERNET_STATUS_CONNECTING_TO_SERVER:  TranslateStatusId = "INTERNET_STATUS_CONNECTING_TO_SERVER"
        Case INTERNET_STATUS_CONNECTION_CLOSED:     TranslateStatusId = "INTERNET_STATUS_CONNECTION_CLOSED"
        Case INTERNET_STATUS_CTL_RESPONSE_RECEIVED: TranslateStatusId = "INTERNET_STATUS_CTL_RESPONSE_RECEIVED"
        Case INTERNET_STATUS_DETECTING_PROXY:       TranslateStatusId = "INTERNET_STATUS_DETECTING_PROXY"
        Case INTERNET_STATUS_HANDLE_CLOSING:        TranslateStatusId = "INTERNET_STATUS_HANDLE_CLOSING"
        Case INTERNET_STATUS_HANDLE_CREATED:        TranslateStatusId = "INTERNET_STATUS_HANDLE_CREATED"
        Case INTERNET_STATUS_INTERMEDIATE_RESPONSE: TranslateStatusId = "INTERNET_STATUS_INTERMEDIATE_RESPONSE"
        Case INTERNET_STATUS_NAME_RESOLVED:         TranslateStatusId = "INTERNET_STATUS_NAME_RESOLVED"
        Case INTERNET_STATUS_PREFETCH:              TranslateStatusId = "INTERNET_STATUS_PREFETCH"
        Case INTERNET_STATUS_RECEIVING_RESPONSE:    TranslateStatusId = "INTERNET_STATUS_RECEIVING_RESPONSE"
        Case INTERNET_STATUS_REDIRECT:              TranslateStatusId = "INTERNET_STATUS_REDIRECT"
        Case INTERNET_STATUS_REQUEST_COMPLETE:      TranslateStatusId = "INTERNET_STATUS_REQUEST_COMPLETE"
        Case INTERNET_STATUS_REQUEST_SENT:          TranslateStatusId = "INTERNET_STATUS_REQUEST_SENT"
        Case INTERNET_STATUS_RESOLVING_NAME:        TranslateStatusId = "INTERNET_STATUS_RESOLVING_NAME"
        Case INTERNET_STATUS_RESPONSE_RECEIVED:     TranslateStatusId = "INTERNET_STATUS_RESPONSE_RECEIVED"
        Case INTERNET_STATUS_SENDING_REQUEST:       TranslateStatusId = "INTERNET_STATUS_SENDING_REQUEST"
        Case INTERNET_STATUS_STATE_CHANGE:          TranslateStatusId = "INTERNET_STATUS_STATE_CHANGE"
        Case INTERNET_STATE_CONNECTED:              TranslateStatusId = "INTERNET_STATE_CONNECTED"
        Case INTERNET_STATE_DISCONNECTED:           TranslateStatusId = "INTERNET_STATE_DISCONNECTED"
        Case INTERNET_STATE_DISCONNECTED_BY_USER:   TranslateStatusId = "INTERNET_STATE_DISCONNECTED_BY_USER"
        Case INTERNET_STATE_IDLE:                   TranslateStatusId = "INTERNET_STATE_IDLE"
        Case INTERNET_STATE_BUSY:                   TranslateStatusId = "INTERNET_STATE_BUSY"
        Case INTERNET_STATUS_USER_INPUT_REQUIRED:   TranslateStatusId = "INTERNET_STATUS_USER_INPUT_REQUIRED"
    End Select
End Function
